## Script (Python) "asPDF"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=templatename=None, documentname=None, resultname=None, encoding='iso-8859-15'
##title=Traveral helper to render report
##

request = context.REQUEST

if len(traverse_subpath) >= 2:
    templatename = traverse_subpath[0]
    documentname = traverse_subpath[1]
    if len(traverse_subpath) >= 3:
        resultname = traverse_subpath[2]

if templatename and documentname:
    if not resultname:
        resultname = context.id + '.pdf'
    
    report_tool = context.portal_report
    template_pt = getattr(context, templatename, None)
    doc_pt      = getattr(context, documentname,None)

    if template_pt and doc_pt:
        # page templates are rendered to iso-8859-15 bytes strings
        rendered_template = template_pt()
        rendered_template = unicode(rendered_template, 'iso-8859-15')
       
        rendered_doc = doc_pt()
        rendered_doc = unicode(rendered_doc, 'iso-8859-15')
        
        pdf = report_tool.renderPDF(rendered_template, rendered_doc, encoding=encoding)
                
        request.RESPONSE.setHeader('Content-Type','application/pdf')
        request.RESPONSE.setHeader('Content-Length',len(pdf))
        request.RESPONSE.setHeader('Content-Disposition','inline;filename=%s' % resultname)
        
        return pdf

url = '%s/%s?%s' % (context.portal_url(),'index_html','portal_status_message=error+using+asPDF.')
return request.RESPONSE.redirect(url)
