from reportlab.platypus import Flowable
from reportlab.lib import colors


# Simple Example

class Circle(Flowable):

    def __init__(self, radius, stroke=1, color=colors.red):
        Flowable.__init__(self)
        # set instance attributes
        self.radius = radius
        self.stroke = stroke
        self.color  = color
        
        # initialize flowable
        self.width = self.height = radius * 2.0


    def draw(self):
        r = self.radius
        self.canv.circle(r, r, r, stroke=self.stroke)



